#include <ArduinoBLE.h>
#include <string.h>

const char *imenaStanj[] = {"idle", "spanje", "obracanje", "vrata", "hoja", "pespromet", "okna", "stikalo", "smrcanje"};

BLEDevice central;
BLEService BTservice("180F");
BLEUnsignedShortCharacteristic sleepState("2A19", BLERead | BLENotify);


//---------------------------------------------------------------
//------------ vstavi na dno Setup()
void initBT(){
  if (!BLE.begin()) {
    Serial.println("starting BLE failed!");
    while (1);
  }
  
  pinMode(LED_BUILTIN, OUTPUT);
  BLE.setLocalName("Pametna budilka V1");
  BLE.setAdvertisedService(BTservice);
  BTservice.addCharacteristic(sleepState);
  BLE.addService(BTservice);
  BLE.advertise();
  Serial.println("Bluetooth device active, waiting for connections...");
  
  while (1) {
    central = BLE.central();
    if (central) {
      Serial.print("Connected to central: ");
      Serial.println(central.address());
      digitalWrite(LED_BUILTIN, HIGH);
      break;
    }
  }
}



//  Vsakemu stanju pripada dolocena vrednost:             
//      +---------------+----------+
//      | Stanje spanja | Vrednost |
//      +---------------+----------+
//      | idle          |        0 |
//      | spanje        |        1 |
//      | obracanje     |        2 |
//      | vrata         |        3 |
//      | hoja          |        4 |
//      | pes           |        5 |
//      | promet        |        6 |
//      | okna          |        7 |
//      | stikalo       |        8 |
//      | smrcanje      |        9 |
//      |               |          |
//      |               |          |
//      |               |          |
//      +---------------+----------+
int stateTable(char stanje[]){
  int vrnjenaVrednost;
  for(vrnjenaVrednost = 0; vrnjenaVrednost < ( sizeof(imenaStanj) / sizeof(imenaStanj[0]) ); vrnjenaVrednost++){
    if (strcmp(stanje, imenaStanj[vrnjenaVrednost])== 0){
      return vrnjenaVrednost;      //return prekine izvajanje funkcije
    }
  }
  Serial.println("Neznano stanje:");
  Serial.println(stanje);
  return 0;
}

int findMostCommon(){
  int maxValue = 0;
  for (int i = 0; i < EI_CLASSIFIER_LABEL_COUNT, i++){
    if (result.classification[i].value > result.classification[maxValue].value){
      maxValue = i;
    }
  }
  return maxValue;
}

//-----------------------------------------------------------------------------------------------
//dodaj pred Funkcija run_inference_background() -pred delay(run_inference_every_ms);
void BTsend(char prediction[]){
  // if (central.connected()){
  //   sleepState.writeValue(stateTable(result.classification[findMostCommon()].label));
  // }
  Serial.println(stateTable(result.classification[findMostCommon()].label,  result.classification[findMostCommon()].label, findMostCommon());
}
